<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pyxmpp.jabber.delay</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pyxmpp-module.html">Package&nbsp;pyxmpp</a> ::
        <a href="pyxmpp.jabber-module.html">Package&nbsp;jabber</a> ::
        Module&nbsp;delay
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<h1 class="epydoc">Source Code for <a href="pyxmpp.jabber.delay-module.html">Module pyxmpp.jabber.delay</a></h1>
<pre class="py-src">
<a name="L1"></a><tt class="py-lineno">  1</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L2"></a><tt class="py-lineno">  2</tt>  <tt class="py-line"><tt class="py-comment"># (C) Copyright 2003-2010 Jacek Konieczny &lt;jajcus@jajcus.net&gt;</tt> </tt>
<a name="L3"></a><tt class="py-lineno">  3</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L4"></a><tt class="py-lineno">  4</tt>  <tt class="py-line"><tt class="py-comment"># This program is free software; you can redistribute it and/or modify</tt> </tt>
<a name="L5"></a><tt class="py-lineno">  5</tt>  <tt class="py-line"><tt class="py-comment"># it under the terms of the GNU Lesser General Public License Version</tt> </tt>
<a name="L6"></a><tt class="py-lineno">  6</tt>  <tt class="py-line"><tt class="py-comment"># 2.1 as published by the Free Software Foundation.</tt> </tt>
<a name="L7"></a><tt class="py-lineno">  7</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L8"></a><tt class="py-lineno">  8</tt>  <tt class="py-line"><tt class="py-comment"># This program is distributed in the hope that it will be useful,</tt> </tt>
<a name="L9"></a><tt class="py-lineno">  9</tt>  <tt class="py-line"><tt class="py-comment"># but WITHOUT ANY WARRANTY; without even the implied warranty of</tt> </tt>
<a name="L10"></a><tt class="py-lineno"> 10</tt>  <tt class="py-line"><tt class="py-comment"># MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</tt> </tt>
<a name="L11"></a><tt class="py-lineno"> 11</tt>  <tt class="py-line"><tt class="py-comment"># GNU Lesser General Public License for more details.</tt> </tt>
<a name="L12"></a><tt class="py-lineno"> 12</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L13"></a><tt class="py-lineno"> 13</tt>  <tt class="py-line"><tt class="py-comment"># You should have received a copy of the GNU Lesser General Public</tt> </tt>
<a name="L14"></a><tt class="py-lineno"> 14</tt>  <tt class="py-line"><tt class="py-comment"># License along with this program; if not, write to the Free Software</tt> </tt>
<a name="L15"></a><tt class="py-lineno"> 15</tt>  <tt class="py-line"><tt class="py-comment"># Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.</tt> </tt>
<a name="L16"></a><tt class="py-lineno"> 16</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L17"></a><tt class="py-lineno"> 17</tt>  <tt class="py-line"> </tt>
<a name="L18"></a><tt class="py-lineno"> 18</tt>  <tt class="py-line"><tt class="py-docstring">"""Delayed delivery mark (jabber:x:delay) handling.</tt> </tt>
<a name="L19"></a><tt class="py-lineno"> 19</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L20"></a><tt class="py-lineno"> 20</tt>  <tt class="py-line"><tt class="py-docstring">Normative reference:</tt> </tt>
<a name="L21"></a><tt class="py-lineno"> 21</tt>  <tt class="py-line"><tt class="py-docstring">  - `JEP 91 &lt;http://www.jabber.org/jeps/jep-0091.html&gt;`__</tt> </tt>
<a name="L22"></a><tt class="py-lineno"> 22</tt>  <tt class="py-line"><tt class="py-docstring">"""</tt> </tt>
<a name="L23"></a><tt class="py-lineno"> 23</tt>  <tt class="py-line"> </tt>
<a name="L24"></a><tt class="py-lineno"> 24</tt>  <tt class="py-line"><tt class="py-name">__docformat__</tt><tt class="py-op">=</tt><tt class="py-string">"restructuredtext en"</tt> </tt>
<a name="L25"></a><tt class="py-lineno"> 25</tt>  <tt class="py-line"> </tt>
<a name="L26"></a><tt class="py-lineno"> 26</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">libxml2</tt> </tt>
<a name="L27"></a><tt class="py-lineno"> 27</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">time</tt> </tt>
<a name="L28"></a><tt class="py-lineno"> 28</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">datetime</tt> </tt>
<a name="L29"></a><tt class="py-lineno"> 29</tt>  <tt class="py-line"> </tt>
<a name="L30"></a><tt class="py-lineno"> 30</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-0" class="py-name" targets="Package pyxmpp=pyxmpp-module.html"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-0', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-1" class="py-name" targets="Variable pyxmpp.jabber.disco.DiscoItem.jid=pyxmpp.jabber.disco.DiscoItem-class.html#jid,Module pyxmpp.jid=pyxmpp.jid-module.html"><a title="pyxmpp.jabber.disco.DiscoItem.jid
pyxmpp.jid" class="py-name" href="#" onclick="return doclink('link-1', 'jid', 'link-1');">jid</a></tt> <tt class="py-keyword">import</tt> <tt id="link-2" class="py-name" targets="Class pyxmpp.jid.JID=pyxmpp.jid.JID-class.html"><a title="pyxmpp.jid.JID" class="py-name" href="#" onclick="return doclink('link-2', 'JID', 'link-2');">JID</a></tt> </tt>
<a name="L31"></a><tt class="py-lineno"> 31</tt>  <tt class="py-line"> </tt>
<a name="L32"></a><tt class="py-lineno"> 32</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-3" class="py-name"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-3', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-4" class="py-name" targets="Module pyxmpp.utils=pyxmpp.utils-module.html"><a title="pyxmpp.utils" class="py-name" href="#" onclick="return doclink('link-4', 'utils', 'link-4');">utils</a></tt> <tt class="py-keyword">import</tt> <tt id="link-5" class="py-name" targets="Function pyxmpp.utils.to_utf8()=pyxmpp.utils-module.html#to_utf8"><a title="pyxmpp.utils.to_utf8" class="py-name" href="#" onclick="return doclink('link-5', 'to_utf8', 'link-5');">to_utf8</a></tt><tt class="py-op">,</tt><tt id="link-6" class="py-name" targets="Function pyxmpp.utils.from_utf8()=pyxmpp.utils-module.html#from_utf8"><a title="pyxmpp.utils.from_utf8" class="py-name" href="#" onclick="return doclink('link-6', 'from_utf8', 'link-6');">from_utf8</a></tt> </tt>
<a name="L33"></a><tt class="py-lineno"> 33</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-7" class="py-name"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-7', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-8" class="py-name" targets="Module pyxmpp.xmlextra=pyxmpp.xmlextra-module.html"><a title="pyxmpp.xmlextra" class="py-name" href="#" onclick="return doclink('link-8', 'xmlextra', 'link-8');">xmlextra</a></tt> <tt class="py-keyword">import</tt> <tt id="link-9" class="py-name" targets="Function pyxmpp.xmlextra.get_node_ns_uri()=pyxmpp.xmlextra-module.html#get_node_ns_uri"><a title="pyxmpp.xmlextra.get_node_ns_uri" class="py-name" href="#" onclick="return doclink('link-9', 'get_node_ns_uri', 'link-9');">get_node_ns_uri</a></tt> </tt>
<a name="L34"></a><tt class="py-lineno"> 34</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-10" class="py-name"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-10', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-11" class="py-name"><a title="pyxmpp.utils" class="py-name" href="#" onclick="return doclink('link-11', 'utils', 'link-4');">utils</a></tt> <tt class="py-keyword">import</tt> <tt id="link-12" class="py-name" targets="Function pyxmpp.utils.datetime_utc_to_local()=pyxmpp.utils-module.html#datetime_utc_to_local"><a title="pyxmpp.utils.datetime_utc_to_local" class="py-name" href="#" onclick="return doclink('link-12', 'datetime_utc_to_local', 'link-12');">datetime_utc_to_local</a></tt><tt class="py-op">,</tt><tt id="link-13" class="py-name" targets="Function pyxmpp.utils.datetime_local_to_utc()=pyxmpp.utils-module.html#datetime_local_to_utc"><a title="pyxmpp.utils.datetime_local_to_utc" class="py-name" href="#" onclick="return doclink('link-13', 'datetime_local_to_utc', 'link-13');">datetime_local_to_utc</a></tt> </tt>
<a name="L35"></a><tt class="py-lineno"> 35</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-14" class="py-name"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-14', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-15" class="py-name" targets="Module pyxmpp.objects=pyxmpp.objects-module.html"><a title="pyxmpp.objects" class="py-name" href="#" onclick="return doclink('link-15', 'objects', 'link-15');">objects</a></tt> <tt class="py-keyword">import</tt> <tt id="link-16" class="py-name" targets="Class pyxmpp.objects.StanzaPayloadObject=pyxmpp.objects.StanzaPayloadObject-class.html"><a title="pyxmpp.objects.StanzaPayloadObject" class="py-name" href="#" onclick="return doclink('link-16', 'StanzaPayloadObject', 'link-16');">StanzaPayloadObject</a></tt> </tt>
<a name="L36"></a><tt class="py-lineno"> 36</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-17" class="py-name"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-17', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-18" class="py-name" targets="Module pyxmpp.exceptions=pyxmpp.exceptions-module.html"><a title="pyxmpp.exceptions" class="py-name" href="#" onclick="return doclink('link-18', 'exceptions', 'link-18');">exceptions</a></tt> <tt class="py-keyword">import</tt> <tt id="link-19" class="py-name" targets="Class pyxmpp.exceptions.BadRequestProtocolError=pyxmpp.exceptions.BadRequestProtocolError-class.html"><a title="pyxmpp.exceptions.BadRequestProtocolError" class="py-name" href="#" onclick="return doclink('link-19', 'BadRequestProtocolError', 'link-19');">BadRequestProtocolError</a></tt><tt class="py-op">,</tt> <tt id="link-20" class="py-name" targets="Class pyxmpp.exceptions.JIDMalformedProtocolError=pyxmpp.exceptions.JIDMalformedProtocolError-class.html"><a title="pyxmpp.exceptions.JIDMalformedProtocolError" class="py-name" href="#" onclick="return doclink('link-20', 'JIDMalformedProtocolError', 'link-20');">JIDMalformedProtocolError</a></tt><tt class="py-op">,</tt> <tt id="link-21" class="py-name" targets="Class pyxmpp.exceptions.JIDError=pyxmpp.exceptions.JIDError-class.html"><a title="pyxmpp.exceptions.JIDError" class="py-name" href="#" onclick="return doclink('link-21', 'JIDError', 'link-21');">JIDError</a></tt> </tt>
<a name="L37"></a><tt class="py-lineno"> 37</tt>  <tt class="py-line"> </tt>
<a name="L38"></a><tt class="py-lineno"> 38</tt>  <tt class="py-line"><tt id="link-22" class="py-name" targets="Variable pyxmpp.jabber.delay.DELAY_NS=pyxmpp.jabber.delay-module.html#DELAY_NS"><a title="pyxmpp.jabber.delay.DELAY_NS" class="py-name" href="#" onclick="return doclink('link-22', 'DELAY_NS', 'link-22');">DELAY_NS</a></tt><tt class="py-op">=</tt><tt class="py-string">"jabber:x:delay"</tt> </tt>
<a name="L39"></a><tt class="py-lineno"> 39</tt>  <tt class="py-line"> </tt>
<a name="Delay"></a><div id="Delay-def"><a name="L40"></a><tt class="py-lineno"> 40</tt> <a class="py-toggle" href="#" id="Delay-toggle" onclick="return toggle('Delay');">-</a><tt class="py-line"><tt class="py-keyword">class</tt> <a class="py-def-name" href="pyxmpp.jabber.delay.Delay-class.html">Delay</a><tt class="py-op">(</tt><tt class="py-base-class">StanzaPayloadObject</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="Delay-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="Delay-expanded"><a name="L41"></a><tt class="py-lineno"> 41</tt>  <tt class="py-line">    <tt class="py-docstring">"""</tt> </tt>
<a name="L42"></a><tt class="py-lineno"> 42</tt>  <tt class="py-line"><tt class="py-docstring">    Delayed delivery tag.</tt> </tt>
<a name="L43"></a><tt class="py-lineno"> 43</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L44"></a><tt class="py-lineno"> 44</tt>  <tt class="py-line"><tt class="py-docstring">    Represents 'jabber:x:delay' (JEP-0091) element of a Jabber stanza.</tt> </tt>
<a name="L45"></a><tt class="py-lineno"> 45</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L46"></a><tt class="py-lineno"> 46</tt>  <tt class="py-line"><tt class="py-docstring">    :Ivariables:</tt> </tt>
<a name="L47"></a><tt class="py-lineno"> 47</tt>  <tt class="py-line"><tt class="py-docstring">        - `delay_from`: the "from" value of the delay element</tt> </tt>
<a name="L48"></a><tt class="py-lineno"> 48</tt>  <tt class="py-line"><tt class="py-docstring">        - `reason`: the "reason" (content) of the delay element</tt> </tt>
<a name="L49"></a><tt class="py-lineno"> 49</tt>  <tt class="py-line"><tt class="py-docstring">        - `timestamp`: the UTC timestamp as naive datetime object</tt> </tt>
<a name="L50"></a><tt class="py-lineno"> 50</tt>  <tt class="py-line"><tt class="py-docstring">    """</tt> </tt>
<a name="L51"></a><tt class="py-lineno"> 51</tt>  <tt class="py-line"> </tt>
<a name="L52"></a><tt class="py-lineno"> 52</tt>  <tt class="py-line">    <tt id="link-23" class="py-name" targets="Variable pyxmpp.jabber.dataforms.Field.xml_element_name=pyxmpp.jabber.dataforms.Field-class.html#xml_element_name,Variable pyxmpp.jabber.dataforms.Form.xml_element_name=pyxmpp.jabber.dataforms.Form-class.html#xml_element_name,Variable pyxmpp.jabber.dataforms.Item.xml_element_name=pyxmpp.jabber.dataforms.Item-class.html#xml_element_name,Variable pyxmpp.jabber.dataforms.Option.xml_element_name=pyxmpp.jabber.dataforms.Option-class.html#xml_element_name,Variable pyxmpp.jabber.delay.Delay.xml_element_name=pyxmpp.jabber.delay.Delay-class.html#xml_element_name,Variable pyxmpp.jabber.register.Register.xml_element_name=pyxmpp.jabber.register.Register-class.html#xml_element_name,Variable pyxmpp.jabber.vcard.VCard.xml_element_name=pyxmpp.jabber.vcard.VCard-class.html#xml_element_name,Variable pyxmpp.objects.StanzaPayloadObject.xml_element_name=pyxmpp.objects.StanzaPayloadObject-class.html#xml_element_name,Variable pyxmpp.roster.Roster.xml_element_name=pyxmpp.roster.Roster-class.html#xml_element_name,Variable pyxmpp.roster.RosterItem.xml_element_name=pyxmpp.roster.RosterItem-class.html#xml_element_name"><a title="pyxmpp.jabber.dataforms.Field.xml_element_name
pyxmpp.jabber.dataforms.Form.xml_element_name
pyxmpp.jabber.dataforms.Item.xml_element_name
pyxmpp.jabber.dataforms.Option.xml_element_name
pyxmpp.jabber.delay.Delay.xml_element_name
pyxmpp.jabber.register.Register.xml_element_name
pyxmpp.jabber.vcard.VCard.xml_element_name
pyxmpp.objects.StanzaPayloadObject.xml_element_name
pyxmpp.roster.Roster.xml_element_name
pyxmpp.roster.RosterItem.xml_element_name" class="py-name" href="#" onclick="return doclink('link-23', 'xml_element_name', 'link-23');">xml_element_name</a></tt> <tt class="py-op">=</tt> <tt class="py-string">"x"</tt> </tt>
<a name="L53"></a><tt class="py-lineno"> 53</tt>  <tt class="py-line">    <tt id="link-24" class="py-name" targets="Variable pyxmpp.jabber.dataforms.Field.xml_element_namespace=pyxmpp.jabber.dataforms.Field-class.html#xml_element_namespace,Variable pyxmpp.jabber.dataforms.Form.xml_element_namespace=pyxmpp.jabber.dataforms.Form-class.html#xml_element_namespace,Variable pyxmpp.jabber.dataforms.Item.xml_element_namespace=pyxmpp.jabber.dataforms.Item-class.html#xml_element_namespace,Variable pyxmpp.jabber.dataforms.Option.xml_element_namespace=pyxmpp.jabber.dataforms.Option-class.html#xml_element_namespace,Variable pyxmpp.jabber.delay.Delay.xml_element_namespace=pyxmpp.jabber.delay.Delay-class.html#xml_element_namespace,Variable pyxmpp.jabber.register.Register.xml_element_namespace=pyxmpp.jabber.register.Register-class.html#xml_element_namespace,Variable pyxmpp.jabber.vcard.VCard.xml_element_namespace=pyxmpp.jabber.vcard.VCard-class.html#xml_element_namespace,Variable pyxmpp.objects.StanzaPayloadObject.xml_element_namespace=pyxmpp.objects.StanzaPayloadObject-class.html#xml_element_namespace,Variable pyxmpp.roster.Roster.xml_element_namespace=pyxmpp.roster.Roster-class.html#xml_element_namespace,Variable pyxmpp.roster.RosterItem.xml_element_namespace=pyxmpp.roster.RosterItem-class.html#xml_element_namespace"><a title="pyxmpp.jabber.dataforms.Field.xml_element_namespace
pyxmpp.jabber.dataforms.Form.xml_element_namespace
pyxmpp.jabber.dataforms.Item.xml_element_namespace
pyxmpp.jabber.dataforms.Option.xml_element_namespace
pyxmpp.jabber.delay.Delay.xml_element_namespace
pyxmpp.jabber.register.Register.xml_element_namespace
pyxmpp.jabber.vcard.VCard.xml_element_namespace
pyxmpp.objects.StanzaPayloadObject.xml_element_namespace
pyxmpp.roster.Roster.xml_element_namespace
pyxmpp.roster.RosterItem.xml_element_namespace" class="py-name" href="#" onclick="return doclink('link-24', 'xml_element_namespace', 'link-24');">xml_element_namespace</a></tt> <tt class="py-op">=</tt> <tt id="link-25" class="py-name"><a title="pyxmpp.jabber.delay.DELAY_NS" class="py-name" href="#" onclick="return doclink('link-25', 'DELAY_NS', 'link-22');">DELAY_NS</a></tt> </tt>
<a name="L54"></a><tt class="py-lineno"> 54</tt>  <tt class="py-line"> </tt>
<a name="Delay.__init__"></a><div id="Delay.__init__-def"><a name="L55"></a><tt class="py-lineno"> 55</tt> <a class="py-toggle" href="#" id="Delay.__init__-toggle" onclick="return toggle('Delay.__init__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jabber.delay.Delay-class.html#__init__">__init__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">node_or_datetime</tt><tt class="py-op">,</tt><tt class="py-param">delay_from</tt><tt class="py-op">=</tt><tt class="py-name">None</tt><tt class="py-op">,</tt><tt class="py-param">reason</tt><tt class="py-op">=</tt><tt class="py-name">None</tt><tt class="py-op">,</tt><tt class="py-param">utc</tt><tt class="py-op">=</tt><tt class="py-name">True</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="Delay.__init__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="Delay.__init__-expanded"><a name="L56"></a><tt class="py-lineno"> 56</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L57"></a><tt class="py-lineno"> 57</tt>  <tt class="py-line"><tt class="py-docstring">        Initialize the Delay object.</tt> </tt>
<a name="L58"></a><tt class="py-lineno"> 58</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L59"></a><tt class="py-lineno"> 59</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L60"></a><tt class="py-lineno"> 60</tt>  <tt class="py-line"><tt class="py-docstring">            - `node_or_datetime`: an XML node to parse or the timestamp.</tt> </tt>
<a name="L61"></a><tt class="py-lineno"> 61</tt>  <tt class="py-line"><tt class="py-docstring">            - `delay_from`: JID of the entity which adds the delay mark</tt> </tt>
<a name="L62"></a><tt class="py-lineno"> 62</tt>  <tt class="py-line"><tt class="py-docstring">              (when `node_or_datetime` is a timestamp).</tt> </tt>
<a name="L63"></a><tt class="py-lineno"> 63</tt>  <tt class="py-line"><tt class="py-docstring">            - `reason`: reason of the delay (when `node_or_datetime` is a</tt> </tt>
<a name="L64"></a><tt class="py-lineno"> 64</tt>  <tt class="py-line"><tt class="py-docstring">              timestamp).</tt> </tt>
<a name="L65"></a><tt class="py-lineno"> 65</tt>  <tt class="py-line"><tt class="py-docstring">            - `utc`: if `True` then the timestamp is assumed to be UTC,</tt> </tt>
<a name="L66"></a><tt class="py-lineno"> 66</tt>  <tt class="py-line"><tt class="py-docstring">              otherwise it is assumed to be local time.</tt> </tt>
<a name="L67"></a><tt class="py-lineno"> 67</tt>  <tt class="py-line"><tt class="py-docstring">        :Types:</tt> </tt>
<a name="L68"></a><tt class="py-lineno"> 68</tt>  <tt class="py-line"><tt class="py-docstring">            - `node_or_datetime`: `libxml2.xmlNode` or `datetime.datetime`</tt> </tt>
<a name="L69"></a><tt class="py-lineno"> 69</tt>  <tt class="py-line"><tt class="py-docstring">            - `delay_from`: `pyxmpp.JID`</tt> </tt>
<a name="L70"></a><tt class="py-lineno"> 70</tt>  <tt class="py-line"><tt class="py-docstring">            - `reason`: `unicode`</tt> </tt>
<a name="L71"></a><tt class="py-lineno"> 71</tt>  <tt class="py-line"><tt class="py-docstring">            - `utc`: `bool`"""</tt> </tt>
<a name="L72"></a><tt class="py-lineno"> 72</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">isinstance</tt><tt class="py-op">(</tt><tt class="py-name">node_or_datetime</tt><tt class="py-op">,</tt><tt class="py-name">libxml2</tt><tt class="py-op">.</tt><tt class="py-name">xmlNode</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L73"></a><tt class="py-lineno"> 73</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-26" class="py-name" targets="Method pyxmpp.jabber.delay.Delay.from_xml()=pyxmpp.jabber.delay.Delay-class.html#from_xml,Method pyxmpp.roster.Roster.from_xml()=pyxmpp.roster.Roster-class.html#from_xml,Method pyxmpp.roster.RosterItem.from_xml()=pyxmpp.roster.RosterItem-class.html#from_xml"><a title="pyxmpp.jabber.delay.Delay.from_xml
pyxmpp.roster.Roster.from_xml
pyxmpp.roster.RosterItem.from_xml" class="py-name" href="#" onclick="return doclink('link-26', 'from_xml', 'link-26');">from_xml</a></tt><tt class="py-op">(</tt><tt class="py-name">node_or_datetime</tt><tt class="py-op">)</tt> </tt>
<a name="L74"></a><tt class="py-lineno"> 74</tt>  <tt class="py-line">        <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L75"></a><tt class="py-lineno"> 75</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-name">utc</tt><tt class="py-op">:</tt> </tt>
<a name="L76"></a><tt class="py-lineno"> 76</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-27" class="py-name" targets="Variable pyxmpp.cache.CacheItem.timestamp=pyxmpp.cache.CacheItem-class.html#timestamp"><a title="pyxmpp.cache.CacheItem.timestamp" class="py-name" href="#" onclick="return doclink('link-27', 'timestamp', 'link-27');">timestamp</a></tt><tt class="py-op">=</tt><tt class="py-name">node_or_datetime</tt> </tt>
<a name="L77"></a><tt class="py-lineno"> 77</tt>  <tt class="py-line">            <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L78"></a><tt class="py-lineno"> 78</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-28" class="py-name"><a title="pyxmpp.cache.CacheItem.timestamp" class="py-name" href="#" onclick="return doclink('link-28', 'timestamp', 'link-27');">timestamp</a></tt><tt class="py-op">=</tt><tt id="link-29" class="py-name"><a title="pyxmpp.utils.datetime_local_to_utc" class="py-name" href="#" onclick="return doclink('link-29', 'datetime_local_to_utc', 'link-13');">datetime_local_to_utc</a></tt><tt class="py-op">(</tt><tt class="py-name">node_or_datetime</tt><tt class="py-op">)</tt> </tt>
<a name="L79"></a><tt class="py-lineno"> 79</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">delay_from</tt><tt class="py-op">=</tt><tt id="link-30" class="py-name"><a title="pyxmpp.jid.JID" class="py-name" href="#" onclick="return doclink('link-30', 'JID', 'link-2');">JID</a></tt><tt class="py-op">(</tt><tt class="py-name">delay_from</tt><tt class="py-op">)</tt> </tt>
<a name="L80"></a><tt class="py-lineno"> 80</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">reason</tt><tt class="py-op">=</tt><tt class="py-name">unicode</tt><tt class="py-op">(</tt><tt class="py-name">reason</tt><tt class="py-op">)</tt> </tt>
</div><a name="L81"></a><tt class="py-lineno"> 81</tt>  <tt class="py-line"> </tt>
<a name="Delay.from_xml"></a><div id="Delay.from_xml-def"><a name="L82"></a><tt class="py-lineno"> 82</tt> <a class="py-toggle" href="#" id="Delay.from_xml-toggle" onclick="return toggle('Delay.from_xml');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jabber.delay.Delay-class.html#from_xml">from_xml</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">xmlnode</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="Delay.from_xml-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="Delay.from_xml-expanded"><a name="L83"></a><tt class="py-lineno"> 83</tt>  <tt class="py-line">        <tt class="py-docstring">"""Initialize Delay object from an XML node.</tt> </tt>
<a name="L84"></a><tt class="py-lineno"> 84</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L85"></a><tt class="py-lineno"> 85</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L86"></a><tt class="py-lineno"> 86</tt>  <tt class="py-line"><tt class="py-docstring">            - `xmlnode`: the jabber:x:delay XML element.</tt> </tt>
<a name="L87"></a><tt class="py-lineno"> 87</tt>  <tt class="py-line"><tt class="py-docstring">        :Types:</tt> </tt>
<a name="L88"></a><tt class="py-lineno"> 88</tt>  <tt class="py-line"><tt class="py-docstring">            - `xmlnode`: `libxml2.xmlNode`"""</tt> </tt>
<a name="L89"></a><tt class="py-lineno"> 89</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">xmlnode</tt><tt class="py-op">.</tt><tt id="link-31" class="py-name" targets="Variable pyxmpp.jabber.disco.DiscoIdentity.type=pyxmpp.jabber.disco.DiscoIdentity-class.html#type"><a title="pyxmpp.jabber.disco.DiscoIdentity.type" class="py-name" href="#" onclick="return doclink('link-31', 'type', 'link-31');">type</a></tt><tt class="py-op">!=</tt><tt class="py-string">"element"</tt><tt class="py-op">:</tt> </tt>
<a name="L90"></a><tt class="py-lineno"> 90</tt>  <tt class="py-line">            <tt class="py-keyword">raise</tt> <tt class="py-name">ValueError</tt><tt class="py-op">,</tt><tt class="py-string">"XML node is not a jabber:x:delay element (not an element)"</tt> </tt>
<a name="L91"></a><tt class="py-lineno"> 91</tt>  <tt class="py-line">        <tt id="link-32" class="py-name" targets="Variable pyxmpp.jabber.muccore.MucAdminQuery.ns=pyxmpp.jabber.muccore.MucAdminQuery-class.html#ns,Variable pyxmpp.jabber.muccore.MucUserX.ns=pyxmpp.jabber.muccore.MucUserX-class.html#ns,Variable pyxmpp.jabber.muccore.MucX.ns=pyxmpp.jabber.muccore.MucX-class.html#ns,Variable pyxmpp.jabber.muccore.MucXBase.ns=pyxmpp.jabber.muccore.MucXBase-class.html#ns"><a title="pyxmpp.jabber.muccore.MucAdminQuery.ns
pyxmpp.jabber.muccore.MucUserX.ns
pyxmpp.jabber.muccore.MucX.ns
pyxmpp.jabber.muccore.MucXBase.ns" class="py-name" href="#" onclick="return doclink('link-32', 'ns', 'link-32');">ns</a></tt><tt class="py-op">=</tt><tt id="link-33" class="py-name"><a title="pyxmpp.xmlextra.get_node_ns_uri" class="py-name" href="#" onclick="return doclink('link-33', 'get_node_ns_uri', 'link-9');">get_node_ns_uri</a></tt><tt class="py-op">(</tt><tt class="py-name">xmlnode</tt><tt class="py-op">)</tt> </tt>
<a name="L92"></a><tt class="py-lineno"> 92</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt id="link-34" class="py-name"><a title="pyxmpp.jabber.muccore.MucAdminQuery.ns
pyxmpp.jabber.muccore.MucUserX.ns
pyxmpp.jabber.muccore.MucX.ns
pyxmpp.jabber.muccore.MucXBase.ns" class="py-name" href="#" onclick="return doclink('link-34', 'ns', 'link-32');">ns</a></tt> <tt class="py-keyword">and</tt> <tt id="link-35" class="py-name"><a title="pyxmpp.jabber.muccore.MucAdminQuery.ns
pyxmpp.jabber.muccore.MucUserX.ns
pyxmpp.jabber.muccore.MucX.ns
pyxmpp.jabber.muccore.MucXBase.ns" class="py-name" href="#" onclick="return doclink('link-35', 'ns', 'link-32');">ns</a></tt><tt class="py-op">!=</tt><tt id="link-36" class="py-name"><a title="pyxmpp.jabber.delay.DELAY_NS" class="py-name" href="#" onclick="return doclink('link-36', 'DELAY_NS', 'link-22');">DELAY_NS</a></tt> <tt class="py-keyword">or</tt> <tt class="py-name">xmlnode</tt><tt class="py-op">.</tt><tt id="link-37" class="py-name" targets="Variable pyxmpp.all.name=pyxmpp.all-module.html#name,Variable pyxmpp.interfaces.name=pyxmpp.interfaces-module.html#name,Variable pyxmpp.jabber.all.name=pyxmpp.jabber.all-module.html#name,Variable pyxmpp.jabber.disco.DiscoIdentity.name=pyxmpp.jabber.disco.DiscoIdentity-class.html#name,Variable pyxmpp.jabber.disco.DiscoItem.name=pyxmpp.jabber.disco.DiscoItem-class.html#name,Variable pyxmpp.jabberd.all.name=pyxmpp.jabberd.all-module.html#name"><a title="pyxmpp.all.name
pyxmpp.interfaces.name
pyxmpp.jabber.all.name
pyxmpp.jabber.disco.DiscoIdentity.name
pyxmpp.jabber.disco.DiscoItem.name
pyxmpp.jabberd.all.name" class="py-name" href="#" onclick="return doclink('link-37', 'name', 'link-37');">name</a></tt><tt class="py-op">!=</tt><tt class="py-string">"x"</tt><tt class="py-op">:</tt> </tt>
<a name="L93"></a><tt class="py-lineno"> 93</tt>  <tt class="py-line">            <tt class="py-keyword">raise</tt> <tt class="py-name">ValueError</tt><tt class="py-op">,</tt><tt class="py-string">"XML node is not a jabber:x:delay element"</tt> </tt>
<a name="L94"></a><tt class="py-lineno"> 94</tt>  <tt class="py-line">        <tt class="py-name">stamp</tt><tt class="py-op">=</tt><tt class="py-name">xmlnode</tt><tt class="py-op">.</tt><tt class="py-name">prop</tt><tt class="py-op">(</tt><tt class="py-string">"stamp"</tt><tt class="py-op">)</tt> </tt>
<a name="L95"></a><tt class="py-lineno"> 95</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">stamp</tt><tt class="py-op">.</tt><tt class="py-name">endswith</tt><tt class="py-op">(</tt><tt class="py-string">"Z"</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L96"></a><tt class="py-lineno"> 96</tt>  <tt class="py-line">            <tt class="py-name">stamp</tt><tt class="py-op">=</tt><tt class="py-name">stamp</tt><tt class="py-op">[</tt><tt class="py-op">:</tt><tt class="py-op">-</tt><tt class="py-number">1</tt><tt class="py-op">]</tt> </tt>
<a name="L97"></a><tt class="py-lineno"> 97</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-string">"-"</tt> <tt class="py-keyword">in</tt> <tt class="py-name">stamp</tt><tt class="py-op">:</tt> </tt>
<a name="L98"></a><tt class="py-lineno"> 98</tt>  <tt class="py-line">            <tt class="py-name">stamp</tt><tt class="py-op">=</tt><tt class="py-name">stamp</tt><tt class="py-op">.</tt><tt class="py-name">split</tt><tt class="py-op">(</tt><tt class="py-string">"-"</tt><tt class="py-op">,</tt><tt class="py-number">1</tt><tt class="py-op">)</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt> </tt>
<a name="L99"></a><tt class="py-lineno"> 99</tt>  <tt class="py-line">        <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L100"></a><tt class="py-lineno">100</tt>  <tt class="py-line">            <tt class="py-name">tm</tt> <tt class="py-op">=</tt> <tt class="py-name">time</tt><tt class="py-op">.</tt><tt class="py-name">strptime</tt><tt class="py-op">(</tt><tt class="py-name">stamp</tt><tt class="py-op">,</tt> <tt class="py-string">"%Y%m%dT%H:%M:%S"</tt><tt class="py-op">)</tt> </tt>
<a name="L101"></a><tt class="py-lineno">101</tt>  <tt class="py-line">        <tt class="py-keyword">except</tt> <tt class="py-name">ValueError</tt><tt class="py-op">:</tt> </tt>
<a name="L102"></a><tt class="py-lineno">102</tt>  <tt class="py-line">            <tt class="py-keyword">raise</tt> <tt id="link-38" class="py-name"><a title="pyxmpp.exceptions.BadRequestProtocolError" class="py-name" href="#" onclick="return doclink('link-38', 'BadRequestProtocolError', 'link-19');">BadRequestProtocolError</a></tt><tt class="py-op">,</tt> <tt class="py-string">"Bad timestamp"</tt> </tt>
<a name="L103"></a><tt class="py-lineno">103</tt>  <tt class="py-line">        <tt class="py-name">tm</tt><tt class="py-op">=</tt><tt class="py-name">tm</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">:</tt><tt class="py-number">8</tt><tt class="py-op">]</tt><tt class="py-op">+</tt><tt class="py-op">(</tt><tt class="py-number">0</tt><tt class="py-op">,</tt><tt class="py-op">)</tt> </tt>
<a name="L104"></a><tt class="py-lineno">104</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-39" class="py-name"><a title="pyxmpp.cache.CacheItem.timestamp" class="py-name" href="#" onclick="return doclink('link-39', 'timestamp', 'link-27');">timestamp</a></tt><tt class="py-op">=</tt><tt class="py-name">datetime</tt><tt class="py-op">.</tt><tt class="py-name">datetime</tt><tt class="py-op">.</tt><tt class="py-name">fromtimestamp</tt><tt class="py-op">(</tt><tt class="py-name">time</tt><tt class="py-op">.</tt><tt class="py-name">mktime</tt><tt class="py-op">(</tt><tt class="py-name">tm</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L105"></a><tt class="py-lineno">105</tt>  <tt class="py-line">        <tt class="py-name">delay_from</tt><tt class="py-op">=</tt><tt id="link-40" class="py-name"><a title="pyxmpp.utils.from_utf8" class="py-name" href="#" onclick="return doclink('link-40', 'from_utf8', 'link-6');">from_utf8</a></tt><tt class="py-op">(</tt><tt class="py-name">xmlnode</tt><tt class="py-op">.</tt><tt class="py-name">prop</tt><tt class="py-op">(</tt><tt class="py-string">"from"</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L106"></a><tt class="py-lineno">106</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">delay_from</tt><tt class="py-op">:</tt> </tt>
<a name="L107"></a><tt class="py-lineno">107</tt>  <tt class="py-line">            <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L108"></a><tt class="py-lineno">108</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">delay_from</tt> <tt class="py-op">=</tt> <tt id="link-41" class="py-name"><a title="pyxmpp.jid.JID" class="py-name" href="#" onclick="return doclink('link-41', 'JID', 'link-2');">JID</a></tt><tt class="py-op">(</tt><tt class="py-name">delay_from</tt><tt class="py-op">)</tt> </tt>
<a name="L109"></a><tt class="py-lineno">109</tt>  <tt class="py-line">            <tt class="py-keyword">except</tt> <tt id="link-42" class="py-name"><a title="pyxmpp.exceptions.JIDError" class="py-name" href="#" onclick="return doclink('link-42', 'JIDError', 'link-21');">JIDError</a></tt><tt class="py-op">:</tt> </tt>
<a name="L110"></a><tt class="py-lineno">110</tt>  <tt class="py-line">                <tt class="py-keyword">raise</tt> <tt id="link-43" class="py-name"><a title="pyxmpp.exceptions.JIDMalformedProtocolError" class="py-name" href="#" onclick="return doclink('link-43', 'JIDMalformedProtocolError', 'link-20');">JIDMalformedProtocolError</a></tt><tt class="py-op">,</tt> <tt class="py-string">"Bad JID in the jabber:x:delay 'from' attribute"</tt> </tt>
<a name="L111"></a><tt class="py-lineno">111</tt>  <tt class="py-line">        <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L112"></a><tt class="py-lineno">112</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">delay_from</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt> </tt>
<a name="L113"></a><tt class="py-lineno">113</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">reason</tt> <tt class="py-op">=</tt> <tt id="link-44" class="py-name"><a title="pyxmpp.utils.from_utf8" class="py-name" href="#" onclick="return doclink('link-44', 'from_utf8', 'link-6');">from_utf8</a></tt><tt class="py-op">(</tt><tt class="py-name">xmlnode</tt><tt class="py-op">.</tt><tt class="py-name">getContent</tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
</div><a name="L114"></a><tt class="py-lineno">114</tt>  <tt class="py-line"> </tt>
<a name="Delay.complete_xml_element"></a><div id="Delay.complete_xml_element-def"><a name="L115"></a><tt class="py-lineno">115</tt> <a class="py-toggle" href="#" id="Delay.complete_xml_element-toggle" onclick="return toggle('Delay.complete_xml_element');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jabber.delay.Delay-class.html#complete_xml_element">complete_xml_element</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">xmlnode</tt><tt class="py-op">,</tt> <tt class="py-param">_unused</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="Delay.complete_xml_element-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="Delay.complete_xml_element-expanded"><a name="L116"></a><tt class="py-lineno">116</tt>  <tt class="py-line">        <tt class="py-docstring">"""Complete the XML node with `self` content.</tt> </tt>
<a name="L117"></a><tt class="py-lineno">117</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L118"></a><tt class="py-lineno">118</tt>  <tt class="py-line"><tt class="py-docstring">        Should be overriden in classes derived from `StanzaPayloadObject`.</tt> </tt>
<a name="L119"></a><tt class="py-lineno">119</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L120"></a><tt class="py-lineno">120</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L121"></a><tt class="py-lineno">121</tt>  <tt class="py-line"><tt class="py-docstring">            - `xmlnode`: XML node with the element being built. It has already</tt> </tt>
<a name="L122"></a><tt class="py-lineno">122</tt>  <tt class="py-line"><tt class="py-docstring">              right name and namespace, but no attributes or content.</tt> </tt>
<a name="L123"></a><tt class="py-lineno">123</tt>  <tt class="py-line"><tt class="py-docstring">            - `_unused`: document to which the element belongs.</tt> </tt>
<a name="L124"></a><tt class="py-lineno">124</tt>  <tt class="py-line"><tt class="py-docstring">        :Types:</tt> </tt>
<a name="L125"></a><tt class="py-lineno">125</tt>  <tt class="py-line"><tt class="py-docstring">            - `xmlnode`: `libxml2.xmlNode`</tt> </tt>
<a name="L126"></a><tt class="py-lineno">126</tt>  <tt class="py-line"><tt class="py-docstring">            - `_unused`: `libxml2.xmlDoc`"""</tt> </tt>
<a name="L127"></a><tt class="py-lineno">127</tt>  <tt class="py-line">        <tt class="py-name">tm</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-45" class="py-name"><a title="pyxmpp.cache.CacheItem.timestamp" class="py-name" href="#" onclick="return doclink('link-45', 'timestamp', 'link-27');">timestamp</a></tt><tt class="py-op">.</tt><tt class="py-name">strftime</tt><tt class="py-op">(</tt><tt class="py-string">"%Y%m%dT%H:%M:%S"</tt><tt class="py-op">)</tt> </tt>
<a name="L128"></a><tt class="py-lineno">128</tt>  <tt class="py-line">        <tt class="py-name">xmlnode</tt><tt class="py-op">.</tt><tt class="py-name">setProp</tt><tt class="py-op">(</tt><tt class="py-string">"stamp"</tt><tt class="py-op">,</tt><tt class="py-name">tm</tt><tt class="py-op">)</tt> </tt>
<a name="L129"></a><tt class="py-lineno">129</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">delay_from</tt><tt class="py-op">:</tt> </tt>
<a name="L130"></a><tt class="py-lineno">130</tt>  <tt class="py-line">            <tt class="py-name">xmlnode</tt><tt class="py-op">.</tt><tt class="py-name">setProp</tt><tt class="py-op">(</tt><tt class="py-string">"from"</tt><tt class="py-op">,</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">delay_from</tt><tt class="py-op">.</tt><tt id="link-46" class="py-name" targets="Method pyxmpp.jid.JID.as_utf8()=pyxmpp.jid.JID-class.html#as_utf8"><a title="pyxmpp.jid.JID.as_utf8" class="py-name" href="#" onclick="return doclink('link-46', 'as_utf8', 'link-46');">as_utf8</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L131"></a><tt class="py-lineno">131</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">reason</tt><tt class="py-op">:</tt> </tt>
<a name="L132"></a><tt class="py-lineno">132</tt>  <tt class="py-line">            <tt class="py-name">xmlnode</tt><tt class="py-op">.</tt><tt class="py-name">setContent</tt><tt class="py-op">(</tt><tt id="link-47" class="py-name"><a title="pyxmpp.utils.to_utf8" class="py-name" href="#" onclick="return doclink('link-47', 'to_utf8', 'link-5');">to_utf8</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">reason</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
</div><a name="L133"></a><tt class="py-lineno">133</tt>  <tt class="py-line"> </tt>
<a name="Delay.get_datetime_local"></a><div id="Delay.get_datetime_local-def"><a name="L134"></a><tt class="py-lineno">134</tt> <a class="py-toggle" href="#" id="Delay.get_datetime_local-toggle" onclick="return toggle('Delay.get_datetime_local');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jabber.delay.Delay-class.html#get_datetime_local">get_datetime_local</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="Delay.get_datetime_local-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="Delay.get_datetime_local-expanded"><a name="L135"></a><tt class="py-lineno">135</tt>  <tt class="py-line">        <tt class="py-docstring">"""Get the timestamp as a local time.</tt> </tt>
<a name="L136"></a><tt class="py-lineno">136</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L137"></a><tt class="py-lineno">137</tt>  <tt class="py-line"><tt class="py-docstring">        :return: the timestamp of the delay element represented in the local</tt> </tt>
<a name="L138"></a><tt class="py-lineno">138</tt>  <tt class="py-line"><tt class="py-docstring">          timezone.</tt> </tt>
<a name="L139"></a><tt class="py-lineno">139</tt>  <tt class="py-line"><tt class="py-docstring">        :returntype: `datetime.datetime`"""</tt> </tt>
<a name="L140"></a><tt class="py-lineno">140</tt>  <tt class="py-line">        <tt class="py-name">r</tt><tt class="py-op">=</tt><tt id="link-48" class="py-name"><a title="pyxmpp.utils.datetime_utc_to_local" class="py-name" href="#" onclick="return doclink('link-48', 'datetime_utc_to_local', 'link-12');">datetime_utc_to_local</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-49" class="py-name"><a title="pyxmpp.cache.CacheItem.timestamp" class="py-name" href="#" onclick="return doclink('link-49', 'timestamp', 'link-27');">timestamp</a></tt><tt class="py-op">)</tt> </tt>
<a name="L141"></a><tt class="py-lineno">141</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">r</tt> </tt>
</div><a name="L142"></a><tt class="py-lineno">142</tt>  <tt class="py-line"> </tt>
<a name="Delay.get_datetime_utc"></a><div id="Delay.get_datetime_utc-def"><a name="L143"></a><tt class="py-lineno">143</tt> <a class="py-toggle" href="#" id="Delay.get_datetime_utc-toggle" onclick="return toggle('Delay.get_datetime_utc');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jabber.delay.Delay-class.html#get_datetime_utc">get_datetime_utc</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="Delay.get_datetime_utc-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="Delay.get_datetime_utc-expanded"><a name="L144"></a><tt class="py-lineno">144</tt>  <tt class="py-line">        <tt class="py-docstring">"""Get the timestamp as a UTC.</tt> </tt>
<a name="L145"></a><tt class="py-lineno">145</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L146"></a><tt class="py-lineno">146</tt>  <tt class="py-line"><tt class="py-docstring">        :return: the timestamp of the delay element represented in UTC.</tt> </tt>
<a name="L147"></a><tt class="py-lineno">147</tt>  <tt class="py-line"><tt class="py-docstring">        :returntype: `datetime.datetime`"""</tt> </tt>
<a name="L148"></a><tt class="py-lineno">148</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-50" class="py-name"><a title="pyxmpp.cache.CacheItem.timestamp" class="py-name" href="#" onclick="return doclink('link-50', 'timestamp', 'link-27');">timestamp</a></tt> </tt>
</div><a name="L149"></a><tt class="py-lineno">149</tt>  <tt class="py-line"> </tt>
<a name="Delay.__str__"></a><div id="Delay.__str__-def"><a name="L150"></a><tt class="py-lineno">150</tt> <a class="py-toggle" href="#" id="Delay.__str__-toggle" onclick="return toggle('Delay.__str__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jabber.delay.Delay-class.html#__str__">__str__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="Delay.__str__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="Delay.__str__-expanded"><a name="L151"></a><tt class="py-lineno">151</tt>  <tt class="py-line">        <tt class="py-name">n</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-51" class="py-name" targets="Method pyxmpp.jabber.muccore.MucItem.as_xml()=pyxmpp.jabber.muccore.MucItem-class.html#as_xml,Method pyxmpp.jabber.muccore.MucStatus.as_xml()=pyxmpp.jabber.muccore.MucStatus-class.html#as_xml,Method pyxmpp.jabber.vcard.VCardAdr.as_xml()=pyxmpp.jabber.vcard.VCardAdr-class.html#as_xml,Method pyxmpp.jabber.vcard.VCardCategories.as_xml()=pyxmpp.jabber.vcard.VCardCategories-class.html#as_xml,Method pyxmpp.jabber.vcard.VCardEmail.as_xml()=pyxmpp.jabber.vcard.VCardEmail-class.html#as_xml,Method pyxmpp.jabber.vcard.VCardGeo.as_xml()=pyxmpp.jabber.vcard.VCardGeo-class.html#as_xml,Method pyxmpp.jabber.vcard.VCardImage.as_xml()=pyxmpp.jabber.vcard.VCardImage-class.html#as_xml,Method pyxmpp.jabber.vcard.VCardJID.as_xml()=pyxmpp.jabber.vcard.VCardJID-class.html#as_xml,Method pyxmpp.jabber.vcard.VCardKey.as_xml()=pyxmpp.jabber.vcard.VCardKey-class.html#as_xml,Method pyxmpp.jabber.vcard.VCardLabel.as_xml()=pyxmpp.jabber.vcard.VCardLabel-class.html#as_xml,Method pyxmpp.jabber.vcard.VCardName.as_xml()=pyxmpp.jabber.vcard.VCardName-class.html#as_xml,Method pyxmpp.jabber.vcard.VCardOrg.as_xml()=pyxmpp.jabber.vcard.VCardOrg-class.html#as_xml,Method pyxmpp.jabber.vcard.VCardPrivacy.as_xml()=pyxmpp.jabber.vcard.VCardPrivacy-class.html#as_xml,Method pyxmpp.jabber.vcard.VCardSound.as_xml()=pyxmpp.jabber.vcard.VCardSound-class.html#as_xml,Method pyxmpp.jabber.vcard.VCardString.as_xml()=pyxmpp.jabber.vcard.VCardString-class.html#as_xml,Method pyxmpp.jabber.vcard.VCardTel.as_xml()=pyxmpp.jabber.vcard.VCardTel-class.html#as_xml,Method pyxmpp.objects.StanzaPayloadObject.as_xml()=pyxmpp.objects.StanzaPayloadObject-class.html#as_xml,Method pyxmpp.objects.StanzaPayloadWrapperObject.as_xml()=pyxmpp.objects.StanzaPayloadWrapperObject-class.html#as_xml"><a title="pyxmpp.jabber.muccore.MucItem.as_xml
pyxmpp.jabber.muccore.MucStatus.as_xml
pyxmpp.jabber.vcard.VCardAdr.as_xml
pyxmpp.jabber.vcard.VCardCategories.as_xml
pyxmpp.jabber.vcard.VCardEmail.as_xml
pyxmpp.jabber.vcard.VCardGeo.as_xml
pyxmpp.jabber.vcard.VCardImage.as_xml
pyxmpp.jabber.vcard.VCardJID.as_xml
pyxmpp.jabber.vcard.VCardKey.as_xml
pyxmpp.jabber.vcard.VCardLabel.as_xml
pyxmpp.jabber.vcard.VCardName.as_xml
pyxmpp.jabber.vcard.VCardOrg.as_xml
pyxmpp.jabber.vcard.VCardPrivacy.as_xml
pyxmpp.jabber.vcard.VCardSound.as_xml
pyxmpp.jabber.vcard.VCardString.as_xml
pyxmpp.jabber.vcard.VCardTel.as_xml
pyxmpp.objects.StanzaPayloadObject.as_xml
pyxmpp.objects.StanzaPayloadWrapperObject.as_xml" class="py-name" href="#" onclick="return doclink('link-51', 'as_xml', 'link-51');">as_xml</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L152"></a><tt class="py-lineno">152</tt>  <tt class="py-line">        <tt class="py-name">r</tt><tt class="py-op">=</tt><tt class="py-name">n</tt><tt class="py-op">.</tt><tt id="link-52" class="py-name" targets="Method pyxmpp.error.ErrorNode.serialize()=pyxmpp.error.ErrorNode-class.html#serialize,Method pyxmpp.jabber.muccore.MucXBase.serialize()=pyxmpp.jabber.muccore.MucXBase-class.html#serialize,Method pyxmpp.stanza.Stanza.serialize()=pyxmpp.stanza.Stanza-class.html#serialize"><a title="pyxmpp.error.ErrorNode.serialize
pyxmpp.jabber.muccore.MucXBase.serialize
pyxmpp.stanza.Stanza.serialize" class="py-name" href="#" onclick="return doclink('link-52', 'serialize', 'link-52');">serialize</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L153"></a><tt class="py-lineno">153</tt>  <tt class="py-line">        <tt class="py-name">n</tt><tt class="py-op">.</tt><tt class="py-name">freeNode</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L154"></a><tt class="py-lineno">154</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">r</tt> </tt>
</div><a name="L155"></a><tt class="py-lineno">155</tt>  <tt class="py-line"> </tt>
<a name="Delay.__cmp__"></a><div id="Delay.__cmp__-def"><a name="L156"></a><tt class="py-lineno">156</tt> <a class="py-toggle" href="#" id="Delay.__cmp__-toggle" onclick="return toggle('Delay.__cmp__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jabber.delay.Delay-class.html#__cmp__">__cmp__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt><tt class="py-param">other</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="Delay.__cmp__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="Delay.__cmp__-expanded"><a name="L157"></a><tt class="py-lineno">157</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">cmp</tt><tt class="py-op">(</tt><tt id="link-53" class="py-name"><a title="pyxmpp.cache.CacheItem.timestamp" class="py-name" href="#" onclick="return doclink('link-53', 'timestamp', 'link-27');">timestamp</a></tt><tt class="py-op">,</tt> <tt class="py-name">other</tt><tt class="py-op">.</tt><tt id="link-54" class="py-name"><a title="pyxmpp.cache.CacheItem.timestamp" class="py-name" href="#" onclick="return doclink('link-54', 'timestamp', 'link-27');">timestamp</a></tt><tt class="py-op">)</tt> </tt>
</div></div><a name="L158"></a><tt class="py-lineno">158</tt>  <tt class="py-line"> </tt>
<a name="get_delays"></a><div id="get_delays-def"><a name="L159"></a><tt class="py-lineno">159</tt> <a class="py-toggle" href="#" id="get_delays-toggle" onclick="return toggle('get_delays');">-</a><tt class="py-line"><tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jabber.delay-module.html#get_delays">get_delays</a><tt class="py-op">(</tt><tt class="py-param">stanza</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="get_delays-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="get_delays-expanded"><a name="L160"></a><tt class="py-lineno">160</tt>  <tt class="py-line">    <tt class="py-docstring">"""Get jabber:x:delay elements from the stanza.</tt> </tt>
<a name="L161"></a><tt class="py-lineno">161</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L162"></a><tt class="py-lineno">162</tt>  <tt class="py-line"><tt class="py-docstring">    :Parameters:</tt> </tt>
<a name="L163"></a><tt class="py-lineno">163</tt>  <tt class="py-line"><tt class="py-docstring">        - `stanza`: a, probably delayed, stanza.</tt> </tt>
<a name="L164"></a><tt class="py-lineno">164</tt>  <tt class="py-line"><tt class="py-docstring">    :Types:</tt> </tt>
<a name="L165"></a><tt class="py-lineno">165</tt>  <tt class="py-line"><tt class="py-docstring">        - `stanza`: `pyxmpp.stanza.Stanza`</tt> </tt>
<a name="L166"></a><tt class="py-lineno">166</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L167"></a><tt class="py-lineno">167</tt>  <tt class="py-line"><tt class="py-docstring">    :return: list of delay tags sorted by the timestamp.</tt> </tt>
<a name="L168"></a><tt class="py-lineno">168</tt>  <tt class="py-line"><tt class="py-docstring">    :returntype: `list` of `Delay`"""</tt> </tt>
<a name="L169"></a><tt class="py-lineno">169</tt>  <tt class="py-line">    <tt class="py-name">delays</tt><tt class="py-op">=</tt><tt class="py-op">[</tt><tt class="py-op">]</tt> </tt>
<a name="L170"></a><tt class="py-lineno">170</tt>  <tt class="py-line">    <tt class="py-name">n</tt><tt class="py-op">=</tt><tt id="link-55" class="py-name" targets="Module pyxmpp.stanza=pyxmpp.stanza-module.html,Method pyxmpp.streambase.StreamBase.stanza()=pyxmpp.streambase.StreamBase-class.html#stanza,Method pyxmpp.xmlextra.StreamHandler.stanza()=pyxmpp.xmlextra.StreamHandler-class.html#stanza"><a title="pyxmpp.stanza
pyxmpp.streambase.StreamBase.stanza
pyxmpp.xmlextra.StreamHandler.stanza" class="py-name" href="#" onclick="return doclink('link-55', 'stanza', 'link-55');">stanza</a></tt><tt class="py-op">.</tt><tt class="py-name">xmlnode</tt><tt class="py-op">.</tt><tt class="py-name">children</tt> </tt>
<a name="L171"></a><tt class="py-lineno">171</tt>  <tt class="py-line">    <tt class="py-keyword">while</tt> <tt class="py-name">n</tt><tt class="py-op">:</tt> </tt>
<a name="L172"></a><tt class="py-lineno">172</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">n</tt><tt class="py-op">.</tt><tt id="link-56" class="py-name"><a title="pyxmpp.jabber.disco.DiscoIdentity.type" class="py-name" href="#" onclick="return doclink('link-56', 'type', 'link-31');">type</a></tt><tt class="py-op">==</tt><tt class="py-string">"element"</tt> <tt class="py-keyword">and</tt> <tt id="link-57" class="py-name"><a title="pyxmpp.xmlextra.get_node_ns_uri" class="py-name" href="#" onclick="return doclink('link-57', 'get_node_ns_uri', 'link-9');">get_node_ns_uri</a></tt><tt class="py-op">(</tt><tt class="py-name">n</tt><tt class="py-op">)</tt><tt class="py-op">==</tt><tt id="link-58" class="py-name"><a title="pyxmpp.jabber.delay.DELAY_NS" class="py-name" href="#" onclick="return doclink('link-58', 'DELAY_NS', 'link-22');">DELAY_NS</a></tt> <tt class="py-keyword">and</tt> <tt class="py-name">n</tt><tt class="py-op">.</tt><tt id="link-59" class="py-name"><a title="pyxmpp.all.name
pyxmpp.interfaces.name
pyxmpp.jabber.all.name
pyxmpp.jabber.disco.DiscoIdentity.name
pyxmpp.jabber.disco.DiscoItem.name
pyxmpp.jabberd.all.name" class="py-name" href="#" onclick="return doclink('link-59', 'name', 'link-37');">name</a></tt><tt class="py-op">==</tt><tt class="py-string">"x"</tt><tt class="py-op">:</tt> </tt>
<a name="L173"></a><tt class="py-lineno">173</tt>  <tt class="py-line">            <tt class="py-name">delays</tt><tt class="py-op">.</tt><tt class="py-name">append</tt><tt class="py-op">(</tt><tt id="link-60" class="py-name" targets="Class pyxmpp.jabber.delay.Delay=pyxmpp.jabber.delay.Delay-class.html"><a title="pyxmpp.jabber.delay.Delay" class="py-name" href="#" onclick="return doclink('link-60', 'Delay', 'link-60');">Delay</a></tt><tt class="py-op">(</tt><tt class="py-name">n</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L174"></a><tt class="py-lineno">174</tt>  <tt class="py-line">        <tt class="py-name">n</tt><tt class="py-op">=</tt><tt class="py-name">n</tt><tt class="py-op">.</tt><tt class="py-name">next</tt> </tt>
<a name="L175"></a><tt class="py-lineno">175</tt>  <tt class="py-line">    <tt class="py-name">delays</tt><tt class="py-op">.</tt><tt class="py-name">sort</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L176"></a><tt class="py-lineno">176</tt>  <tt class="py-line">    <tt class="py-keyword">return</tt> <tt class="py-name">delays</tt> </tt>
</div><a name="L177"></a><tt class="py-lineno">177</tt>  <tt class="py-line"> </tt>
<a name="get_delay"></a><div id="get_delay-def"><a name="L178"></a><tt class="py-lineno">178</tt> <a class="py-toggle" href="#" id="get_delay-toggle" onclick="return toggle('get_delay');">-</a><tt class="py-line"><tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.jabber.delay-module.html#get_delay">get_delay</a><tt class="py-op">(</tt><tt class="py-param">stanza</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="get_delay-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="get_delay-expanded"><a name="L179"></a><tt class="py-lineno">179</tt>  <tt class="py-line">    <tt class="py-docstring">"""Get the oldest jabber:x:delay elements from the stanza.</tt> </tt>
<a name="L180"></a><tt class="py-lineno">180</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L181"></a><tt class="py-lineno">181</tt>  <tt class="py-line"><tt class="py-docstring">    :Parameters:</tt> </tt>
<a name="L182"></a><tt class="py-lineno">182</tt>  <tt class="py-line"><tt class="py-docstring">        - `stanza`: a, probably delayed, stanza.</tt> </tt>
<a name="L183"></a><tt class="py-lineno">183</tt>  <tt class="py-line"><tt class="py-docstring">    :Types:</tt> </tt>
<a name="L184"></a><tt class="py-lineno">184</tt>  <tt class="py-line"><tt class="py-docstring">        - `stanza`: `pyxmpp.stanza.Stanza`</tt> </tt>
<a name="L185"></a><tt class="py-lineno">185</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L186"></a><tt class="py-lineno">186</tt>  <tt class="py-line"><tt class="py-docstring">    The return value, if not `None`, contains a quite reliable</tt> </tt>
<a name="L187"></a><tt class="py-lineno">187</tt>  <tt class="py-line"><tt class="py-docstring">    timestamp of a delayed (e.g. from offline storage) message.</tt> </tt>
<a name="L188"></a><tt class="py-lineno">188</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L189"></a><tt class="py-lineno">189</tt>  <tt class="py-line"><tt class="py-docstring">    :return: the oldest delay tag of the stanza or `None`.</tt> </tt>
<a name="L190"></a><tt class="py-lineno">190</tt>  <tt class="py-line"><tt class="py-docstring">    :returntype: `Delay`"""</tt> </tt>
<a name="L191"></a><tt class="py-lineno">191</tt>  <tt class="py-line">    <tt class="py-name">delays</tt><tt class="py-op">=</tt><tt id="link-61" class="py-name" targets="Function pyxmpp.jabber.delay.get_delays()=pyxmpp.jabber.delay-module.html#get_delays"><a title="pyxmpp.jabber.delay.get_delays" class="py-name" href="#" onclick="return doclink('link-61', 'get_delays', 'link-61');">get_delays</a></tt><tt class="py-op">(</tt><tt id="link-62" class="py-name"><a title="pyxmpp.stanza
pyxmpp.streambase.StreamBase.stanza
pyxmpp.xmlextra.StreamHandler.stanza" class="py-name" href="#" onclick="return doclink('link-62', 'stanza', 'link-55');">stanza</a></tt><tt class="py-op">)</tt> </tt>
<a name="L192"></a><tt class="py-lineno">192</tt>  <tt class="py-line">    <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">delays</tt><tt class="py-op">:</tt> </tt>
<a name="L193"></a><tt class="py-lineno">193</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">None</tt> </tt>
<a name="L194"></a><tt class="py-lineno">194</tt>  <tt class="py-line">    <tt class="py-keyword">return</tt> <tt id="link-63" class="py-name"><a title="pyxmpp.jabber.delay.get_delays" class="py-name" href="#" onclick="return doclink('link-63', 'get_delays', 'link-61');">get_delays</a></tt><tt class="py-op">(</tt><tt id="link-64" class="py-name"><a title="pyxmpp.stanza
pyxmpp.streambase.StreamBase.stanza
pyxmpp.xmlextra.StreamHandler.stanza" class="py-name" href="#" onclick="return doclink('link-64', 'stanza', 'link-55');">stanza</a></tt><tt class="py-op">)</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt> </tt>
</div><a name="L195"></a><tt class="py-lineno">195</tt>  <tt class="py-line"> </tt>
<a name="L196"></a><tt class="py-lineno">196</tt>  <tt class="py-line"><tt class="py-comment"># vi: sts=4 et sw=4</tt> </tt>
<a name="L197"></a><tt class="py-lineno">197</tt>  <tt class="py-line"> </tt><script type="text/javascript">
<!--
expandto(location.href);
// -->
</script>
</pre>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sun May  8 13:35:11 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
